/******************************************************************************
		Bisection Method - Algorithm 2.1
*******************************************************************************

To find a solution to f(x) = 0 given the continuous function f on the
interval [a,b] where f(a) and f(b) have opposite signs:

INPUT endpoints a, b; tolerance TOL; maximum number of iterations N0; the
function f():

OUTPUT approximate solution p or message of failure.

*******************************************************************************
*	Written by:  Harold A. Toomey, BYU, Summer 1989, v4.11		      *
******************************************************************************/

#include <stdio.h>		/* for scanf() and printf() */
#include <math.h>		/* for math functions */
#include "naa_util.h"		/* Numerical Analysis Algorithms Utilities. */
#define	PI	3.14159265358979323846264338327950288419716939937510582097


main()
{
  double a, b, p, f(), val, TOL;
  int i, N0;

  get_title();

  printf("Bisection Method - Algorithm 2.1\n\n");
  fprintf(stderr, "Bisection Method - Algorithm 2.1\n\n");

  printf("f(x) = x*x*x + 4.0*x*x - 10.0\n\n");
  /* Needs updating             $           */

  fprintf(stderr, "Enter maximum number of iterations, N0: ");
  scanf("%d", &N0);
  printf("Maximum number of iterations: %d\n", N0);

  fprintf(stderr, "Enter Tolerance TOL (1.0e-4)?: ");
  scanf("%lf", &TOL);
  printf("Tolerance: %lg\n", TOL);

  fprintf(stderr, "Enter endpoint a: ");
  scanf("%lf", &a);
  printf("Endpoint a = %lg\n", a);

  fprintf(stderr, "Enter endpoint b: ");
  scanf("%lf", &b);
  printf("Endpoint b = %lg\n", b);

  /*-------------------------------------------------------------------------*/
  printf("\n n\t a\t\t b\t\t p\t\t f(p)");    /* print out table header */
  printf("\n-----------");
  for (i=1;i<=4;i++)
    printf("---------------");
  printf("\n");
  /*-------------------------------------------------------------------------*/

  /* STEP #1 */
  i = 1;

  /* STEP #2 */
  while (i <= N0) {		/* Do Steps 3-6. */

    /* STEP #3 */
    p = a + (b-a)/2.0;		/* Compute pi */

    /* STEP #4 */		/* val is for speed. */
    printf("% d\t% .9lf\t% .9lf\t% .9lf\t% .9lf\n", i, a, b, p, (val = f(p)));
    if ((val == 0.0) || ((b-a)/2.0 < TOL))
      exit (1);			/* STOP - Procedure completed successfully */

    /* STEP #5 */
    i++;

    /* STEP #6 */
    if (f(a)*val > 0.0)
      a = p;			/* Compute ai, bi. */
    else
      b = p;
  }

  /* STEP #7 */			/* Procedure completed unsuccessfully */
  printf("\nMethod failed after N0 iterations, N0 = %d\n", N0);

}  /* STOP */

/*****************************************************************************/
double f(x)		/* Function to evaluate, f(x). */
double x;
{
  return (x*x*x + 4.0*x*x - 10.0);
}
/*****************************************************************************/
