/******************************************************************************
		Composite Simpson's Rule - Algorithm 4.1
*******************************************************************************
                                [b
To approximate the integral I = |  f(x) dx:
                                ]a
INPUT endpoints a, b; positive integer n; the function f():

OUTPUT approximation XI to I.

*******************************************************************************
*	Written by:  Harold A. Toomey, BYU, Summer 1989, v4.11		      *
******************************************************************************/

#include <stdio.h>		/* for scanf() and printf() */
#include <math.h>		/* for math functions */
#include "naa_util.h"		/* Numerical Analysis Algorithms Utilities. */
#define	PI	3.14159265358979323846264338327950288419716939937510582097


main()
{
  double a, b, h, X, XI, XI0, XI1, XI2, f();
  int i, n;

  get_title();

  printf("Composite Simpson's Rule - Algorithm 4.1\n\n");
  fprintf(stderr, "Composite Simpson's Rule - Algorithm 4.1\n\n");

  printf("f(x) = sin(x)");
  /* Needs updating  $  */

  fprintf(stderr, "Enter endpoint a: ");
  scanf("%lf", &a);

  fprintf(stderr, "Enter endpoint b: ");
  scanf("%lf", &b);

  printf("  from %lg to %lg.\n\n", a, b);

  fprintf(stderr, "Enter even integer n (n = 2m subintervals of [a,b]): ");
  scanf("%d", &n);
  if (n <= 0)
    naaerror("n must be > 0.");	/* ERROR. */
  printf("n = 2m = %d subintervals of [a,b].\n", n);

  if (n % 2 == 1)		/* Checks for odd n. */
    naaerror("Sorry, n must be even.  Aborting computation.");

  /* STEP #1 */
  h = (b-a)/n;
  printf("Interval number h = %lg\n\n", h);

  /* STEP #2 */
  XI0 = f(a) + f(b);
  XI1 = 0.0;			/* Summation of f(x(2i-1)). */
  XI2 = 0.0;			/* Summation of f(x(2i)). */

  /* STEP #3 */
  for (i=1;i<n;i++) {

    /* STEP #4 */
    X = a + i*h;

    /* STEP #5 */
    if (i % 2 == 0)
      XI2 += f(X);		/* For i even. */
    else
      XI1 += f(X);		/* For i odd. */
  }

  /* STEP #6 */
  XI = h*(XI0 + 2.0*XI2 + 4.0*XI1) / 3.0;

  /* STEP #7 */
  printf("    [%lg\n", b);
  printf("I = |  f(x) dx = %.11lg\n", XI);
  printf("    ]%lg\n\n", a);
  printf("Required %d functional evaluations.\n", n+1);

}  				/* STOP */

/*****************************************************************************/
double f(x)		/* Function to evaluate. */
double x;
{
  return (sin(x));
}
/*****************************************************************************/
